From 730a048922431f6a3147febb46667f7f8457fbc9 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Felix=20Scha=CC=88fer?= <felix@fachschaften.org>
Date: Mon, 8 Jul 2013 16:51:11 +0200
Subject: First take on minitest

--HG--
extra : source : 9528a51299741a8fbe4a2197e02d9d0e00b12239
---
 Gemfile                                     |   12 +++--
 lib/tasks/minitest.rake                     |    6 +++
 minitest/minitest_helper.rb                 |   31 ++++++++++++++
 minitest/models/project_test.rb             |   58 +++++++++++++++++++++++++++
 minitest/support/helper_spec.rb             |    6 +++
 minitest/support/helpers/settings_helper.rb |   15 +++++++
 minitest/support/integration_spec.rb        |    5 ++
 minitest/support/model_spec.rb              |   10 +++++
 8 files changed, 138 insertions(+), 5 deletions(-)
 create mode 100644 lib/tasks/minitest.rake
 create mode 100644 minitest/minitest_helper.rb
 create mode 100644 minitest/models/project_test.rb
 create mode 100644 minitest/support/helper_spec.rb
 create mode 100644 minitest/support/helpers/settings_helper.rb
 create mode 100644 minitest/support/integration_spec.rb
 create mode 100644 minitest/support/model_spec.rb

diff --git a/Gemfile b/Gemfile
index c328990..59afab0 100644
--- a/Gemfile
+++ b/Gemfile
@@ -24,12 +24,14 @@ group :test do
   # Shoulda doesn't work nice on 1.9.3 and seems to need test-unit explicitely…
   gem 'test-unit', :platforms => [:mri_19]
   gem 'edavis10-object_daddy', :require => 'object_daddy'
-  gem 'mocha', '0.12.1'
-  # capybara 2 drops ruby 1.8.7 compatibility
-  gem 'capybara', '< 2.0.0'
-  # nokogiri 1.6 requires ruby 1.9.2 or higher
-  gem 'nokogiri', '< 1.6.0'
+  gem 'mocha'
+  gem 'capybara'
   gem 'coveralls', :require => false
+
+  gem 'minitest'
+  gem 'turn'
+  gem 'minitest-matchers'
+  gem 'valid_attribute'
 end
 
 group :ldap do
diff --git a/lib/tasks/minitest.rake b/lib/tasks/minitest.rake
new file mode 100644
index 0000000..44e5bd2
--- /dev/null
+++ b/lib/tasks/minitest.rake
@@ -0,0 +1,6 @@
+require "rake/testtask"
+
+Rake::TestTask.new(:minitest => "db:test:prepare") do |t|
+  t.libs << "minitest"
+  t.pattern = "minitest/**/*_test.rb"
+end
diff --git a/minitest/minitest_helper.rb b/minitest/minitest_helper.rb
new file mode 100644
index 0000000..f478ff1
--- /dev/null
+++ b/minitest/minitest_helper.rb
@@ -0,0 +1,31 @@
+# Load Rails environment
+ENV["RAILS_ENV"] = "test"
+require File.expand_path("../../config/environment", __FILE__)
+
+# Load MiniTest
+require "minitest/autorun"
+require 'capybara/rails'
+require "minitest/matchers"
+require "valid_attribute"
+
+require 'active_support/testing/setup_and_teardown'
+class MiniTest::Spec
+  include ActiveSupport::Callbacks
+  define_callbacks :setup, :teardown
+  include ActiveSupport::Testing::SetupAndTeardown::ForMiniTest
+  extend ActiveSupport::Testing::SetupAndTeardown::ClassMethods
+  # include ActiveSupport::Testing::SetupAndTeardown
+
+  alias_method :method_name, :__name__ if method_defined? :__name__
+end
+
+Turn.config do |c|
+  c.format = :dot
+  c.natural = true
+end
+
+Setting.use_caching = false
+
+Dir[Rails.root.join("minitest", "support", "**", "*.rb")].each do |file|
+  require file
+end
diff --git a/minitest/models/project_test.rb b/minitest/models/project_test.rb
new file mode 100644
index 0000000..bc1733e
--- /dev/null
+++ b/minitest/models/project_test.rb
@@ -0,0 +1,58 @@
+require File.expand_path('../../minitest_helper', __FILE__)
+require 'pp'
+
+describe Project do
+  fixtures :trackers
+
+  describe 'default attributes' do
+    it 'is public by default if configured' do
+      with_settings :default_projects_public => '1' do
+        Project.new.is_public.must_equal true
+        Project.new(:is_public => false).is_public.must_equal false
+      end
+
+      with_settings :default_projects_public => '0' do
+        Project.new.is_public.must_equal false
+        Project.new(:is_public => true).is_public.must_equal true
+      end
+    end
+
+    it "creates sequal project identifiers if configured" do
+      with_settings :sequential_project_identifiers => '1' do
+        # uses project-1 if no project is in the database already
+        identifier = Project.next_identifier || "project-1"
+        Project.new.identifier.must_equal identifier
+        Project.new(:identifier => '').identifier.must_be :blank?
+      end
+
+      with_settings :sequential_project_identifiers => '0' do
+        Project.new.identifier.must_be :blank?
+        Project.new(:identifier => 'test').identifier.must_equal 'test'
+      end
+    end
+
+    it "sets default project modules" do
+      default_modules = ['issue_tracking', 'repository']
+      with_settings :default_projects_modules => default_modules do
+        Project.new.enabled_module_names.must_equal default_modules
+      end
+    end
+
+    it "uses all trackers by default" do
+      Tracker.all.must_equal Project.new.trackers
+      Tracker.find(1, 3).sort_by(&:id).must_equal Project.new(:tracker_ids => [1, 3]).trackers.sort_by(&:id)
+    end
+  end
+
+  it "ensures a valid identifier" do
+    project = Project.new
+
+    %w[abc ab12 ab-12 ab_12].each do |t|
+      project.must have_valid(:identifier).when(t)
+    end
+
+    %w[12 new].each do |t|
+      project.wont have_valid(:identifier).when(t)
+    end
+  end
+end
diff --git a/minitest/support/helper_spec.rb b/minitest/support/helper_spec.rb
new file mode 100644
index 0000000..541d804
--- /dev/null
+++ b/minitest/support/helper_spec.rb
@@ -0,0 +1,6 @@
+class HelperSpec < MiniTest::Spec
+  include ActiveSupport::Testing::SetupAndTeardown
+  include ActionView::TestCase::Behavior
+
+  register_spec_type(/Helper$/, self)
+end
diff --git a/minitest/support/helpers/settings_helper.rb b/minitest/support/helpers/settings_helper.rb
new file mode 100644
index 0000000..849716d
--- /dev/null
+++ b/minitest/support/helpers/settings_helper.rb
@@ -0,0 +1,15 @@
+module MiniTest
+  module Support
+    module Helpers
+      module SettingsHelper
+        def with_settings(options, &block)
+          saved_settings = options.keys.inject({}) {|h, k| h[k] = Setting[k].dup; h}
+          options.each {|k, v| Setting[k] = v}
+          yield
+        ensure
+          saved_settings.each {|k, v| Setting[k] = v}
+        end
+      end
+    end
+  end
+end
diff --git a/minitest/support/integration_spec.rb b/minitest/support/integration_spec.rb
new file mode 100644
index 0000000..c5db945
--- /dev/null
+++ b/minitest/support/integration_spec.rb
@@ -0,0 +1,5 @@
+class IntegrationSpec < MiniTest::Spec
+  include Rails.application.routes.url_helpers
+  include Capybara::DSL
+  register_spec_type(/integration$/, self)
+end
diff --git a/minitest/support/model_spec.rb b/minitest/support/model_spec.rb
new file mode 100644
index 0000000..cda0bf1
--- /dev/null
+++ b/minitest/support/model_spec.rb
@@ -0,0 +1,10 @@
+class ModelSpec < MiniTest::Spec
+  include MiniTest::Support::Helpers::SettingsHelper
+
+  include ActiveRecord::TestFixtures
+  self.fixture_path = Rails.root.join("test", "fixtures")
+
+  register_spec_type(self) do |desc|
+    desc.respond_to?(:ancestors) && desc.ancestors.include?(ActiveRecord::Base)
+  end
+end
-- 
1.7.1


